;۲۲۲۲۲۲۲۲۲۲۲۲۲
;                             Kill Blaj                             
;         A splendid(?) util coded by Mikael Klasson aka Omega          
;   mainly for our 'tiniest prog' contest, but since the others didn't    
;                like the idea, I'm hereby releasing it...               
;                                                                       
;                                        
;                                   +      
;                                          
;                                          
;   +                                  
;                                                   
;                                                        
;                                       
;۲۲۲۲۲۲۲۲۲۲۲۲۲

.model tiny
.code
org     100h
_main:
        mov     dx,offset startupmsg    ; print startup message
        call    _putmsg                 ;

        xor     bx,bx                   ; stt nolla efter cmdlinen
        mov     bl,byte ptr ds:[0080h]  ;
        cmp     bl,0                    ;
        je      _ret                    ;
        mov     byte ptr [bx+81h],0     ;

        mov     ah,1ah                  ; set dta-address = offset dta
        lea     dx,dta                  ;
        int     21h                     ;

        mov     cx,263                  ; nollstll det som ska vara 0
        lea     di,startclearing        ;
        xor     al,al                   ;
        rep     stosb                   ;


newdir:
        mov     ah,4eh                  ; find first
        mov     cx,00027h               ; all entrys except volumes&dirs
        mov     dx,82h                  ; matching cmdline
        int     21h                     ;
        jc      scan4newdirs            ; no such files, next dir..

lop:
        mov     ah,41h                  ; kill it!
        mov     dx,offset dta+1eh       ; filename-pos in dta
        int     21h                     ;
        jnc     nodelerror              ; something went wrong
        mov     dx,offset delerrormsg   ;
        call    _putmsg                 ;
        jmp     _end                    ;
nodelerror:
        inc     fileskilled             ; one more file was killed
        mov     ah,4fh                  ; find next
        int     21h                     ;
        jnc     lop                     ; no more files, next dir

scan4newdirs:
        mov     ah,4eh                  ; find first
        mov     cx,00010h               ; all entrys except volumes
        mov     dx,offset all           ; *.*
        int     21h                     ;
        jc      parent                  ; no more entrys, cd parent

        mov     bx,recursionlevel       ; find appropriate pos in dir
        shl     bx,1                    ;
        mov     cx,dirpos[bx]           ;
        jcxz    dirposlessthan1         ;
findnewdirlop:
        mov     ah,4fh                  ; find next
        int     21h                     ;
        jc      parent                  ; out of files and dirs...
        loop    findnewdirlop           ;

dirposlessthan1:

        mov     bx,recursionlevel       ; inc pos in dir
        shl     bx,1                    ;
        inc     dirpos[bx]              ;

        mov     si,offset dta           ; is it a new dir?
        mov     al,[si+15h]             ;
        test    al,010h                 ;
        jz      scan4newdirs            ;
        mov     si,offset dta           ;
        cmp     byte ptr [si+1eh],'.'   ;
        je      scan4newdirs            ;

        inc     recursionlevel          ; one step further in...

        mov     ah,3bh                  ; cd newdir
        mov     dx,offset dta+1eh       ;
        int     21h                     ;
        inc     dirsscanned             ; one more dir was scanned
        jmp     newdir                  ;

parent:
        mov     bx,recursionlevel       ; set pos in dir at current
        shl     bx,1                    ; recursionlevel to Zero
        mov     dirpos[bx],0            ;
        dec     recursionlevel          ; back back back we go..
        jns     stillinsub              ; done!
        jmp     _end                    ;
stillinsub:
        mov     ah,3bh                  ; cd ..
        mov     dx,offset parentspec    ;
        int     21h                     ;
        jnc     scan4newdirs            ;

_end:
        mov     bx,fileskilled
        call    _printdecword
        mov     dx,offset endmsg1
        call    _putmsg
        mov     bx,dirsscanned
        call    _printdecword
        mov     dx,offset endmsg2
                                        ; put msg and exit
_putmsg:
        mov     ah,9
        int     21h
_ret:
        ret                             ; jepp, exit

;
; In:   BX = Word to print in dec
_printdecword:
        mov     dx,10000
        xor     si,si
        xor     di,di
nextdigit:
        mov     al,0
tryoncemore:
        inc     al
        sub     bx,dx
        jnc     tryoncemore
        cmp     di,0
        jne     putdigit
        cmp     dx,1
        je      putdigit
        cmp     al,1
        je      noputdigit
putdigit:
        add     al,48-1
        int     29h
        inc     di
noputdigit:
        add     bx,dx
        add     si,2
        mov     dx,limits[si]
        cmp     si,5*2
        jb      nextdigit
        ret

;
startupmsg      db      10,'SubKill v1.1 By Mikael Klasson aka Omega',10,13
                db      'Usage: SubKill <files>',10,13,9
                db      'Ex. SubKill *.foo ; SubKill bar??.* ; '
                db      'SubKill kaka.??',10,13,10,'$'
delerrormsg     db      'Couldn''t kill the file(s), '
                db      'strange!$'
endmsg1         db      ' file(s) in $'
endmsg2         db      ' dir(s) killed successfully!$'

limits          dw      10000,1000,100,10,1
all                     db      '*.*',0
dirsscanned             dw      1
parentspec              db      '..'
startclearing           db      ?               ; 0
fileskilled             dw      ?
recursionlevel          dw      ?               ; 0
dirpos                  dw      128 dup(?) ; 0:or; max 128 underkat.niver
                ; fyll totalt 1+2+2+2+128*2=263 0:or from startclearing
dta                     db      2bh dup(?)

;
end _main
